=== src/ai/SConstruct ===
import sys
from subprocess import call
print("scons --directory=../.. " + " ".join(sys.argv[1:]))
Exit(call(Split("scons --directory=../..") + sys.argv[1:]))
