=== debian/changelog ===
wesnoth-1.18 (1:1.18.5-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 24 May 2025 02:12:14 -0700

wesnoth-1.18 (1:1.18.5-1) unstable; urgency=medium

  * New upstream stable release (minor bugfixes and translation updates).
    - Fixes FTBFS with gcc 15. (Closes: #1098091)
  * Bump Standards-Version to 4.7.2, no changes needed.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 23 May 2025 16:00:48 -0700

wesnoth-1.18 (1:1.18.4-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 21 Feb 2025 01:10:36 -0800

wesnoth-1.18 (1:1.18.3-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 22 Nov 2024 03:07:09 -0800
