=== debian/control ===
Source: wesnoth-1.18
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends:
 cmake (>= 3.14),
 debhelper-compat (= 13),
 libboost-coroutine-dev       (>= 1.66.0),
 libboost-filesystem-dev      (>= 1.66.0),
 libboost-graph-dev           (>= 1.66.0),
 libboost-iostreams-dev       (>= 1.66.0),
 libboost-locale-dev          (>= 1.66.0),
 libboost-program-options-dev (>= 1.66.0),
 libboost-random-dev          (>= 1.66.0),
 libboost-regex-dev           (>= 1.66.0),
 libboost-system-dev          (>= 1.66.0),
 libboost-test-dev            (>= 1.66.0),
 libboost-thread-dev          (>= 1.66.0),
 libcairo2-dev (>= 1.10.0),
 libcurl4-openssl-dev,
 libdbus-1-dev,
 libfontconfig-dev (>= 2.4.1),
 libpango1.0-dev (>= 1.44.0),
 libreadline-dev,
 libsdl2-dev (>= 2.0.18),
 libsdl2-image-dev (>= 2.0.2),
 libsdl2-mixer-dev (>= 2.0.0),
 libssl-dev (>= 1.0),
 libvorbis-dev,
 pkgconf,
 python3,
Standards-Version: 4.7.2
Uploaders:
 Rhonda D'Vine <rhonda@debian.org>,
 Vincent Cheng <vcheng@debian.org>,
 P. J. McDermott <pj@pehjota.net>,
Homepage: https://www.wesnoth.org/
Vcs-Git: https://salsa.debian.org/games-team/wesnoth.git
Vcs-Browser: https://salsa.debian.org/games-team/wesnoth
Rules-Requires-Root: no

Package: wesnoth-1.18-data
Architecture: all
Multi-Arch: foreign
Depends:
 fonts-adf-oldania,
 fonts-dejavu-core,
 fonts-dejavu-extra,
 fonts-droid-fallback,
 fonts-lato,
 fonts-lohit-beng-bengali,
 ${misc:Depends},
Suggests:
 wesnoth-1.18-music,
Description: data files for Wesnoth (branch 1.18)
 This package contains the sound files and graphics for Wesnoth. It is required
 for being able to play wesnoth or create maps with the editor.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

# TODO: Remove package after Debian trixie
Package: wesnoth-core
Architecture: all
Section: oldlibs
Depends:
 wesnoth-1.18 (>= ${binary:Version}),
 wesnoth-1.18-data (= ${source:Version}),
 ${misc:Depends},
Description: fantasy turn-based strategy game (transitional package)
 This is a transitional dummy metapackage.  It can safely be removed.
 To play the latest stable version of Wesnoth, install the wesnoth package.
 To play multiplayer games or user-made add-ons without installing all the
 official campaigns and music, install the wesnoth package without recommended
 packages.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18
Architecture: any
Depends:
 wesnoth-1.18-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 wesnoth-1.18-did (= ${source:Version}),
 wesnoth-1.18-dm (= ${source:Version}),
 wesnoth-1.18-dw (= ${source:Version}),
 wesnoth-1.18-ei (= ${source:Version}),
 wesnoth-1.18-httt (= ${source:Version}),
 wesnoth-1.18-l (= ${source:Version}),
 wesnoth-1.18-low (= ${source:Version}),
 wesnoth-1.18-music (= ${source:Version}),
 wesnoth-1.18-nr (= ${source:Version}),
 wesnoth-1.18-sof (= ${source:Version}),
 wesnoth-1.18-sota (= ${source:Version}),
 wesnoth-1.18-sotbe (= ${source:Version}),
 wesnoth-1.18-thot (= ${source:Version}),
 wesnoth-1.18-trow (= ${source:Version}),
 wesnoth-1.18-tsg (= ${source:Version}),
 wesnoth-1.18-ttb (= ${source:Version}),
 wesnoth-1.18-utbs (= ${source:Version}),
 wesnoth-1.18-wof (= ${source:Version}),
Breaks:
 wesnoth-1.18-core (<< 1:1.16.11-1.~),
Replaces:
 wesnoth-1.18-core (<< 1:1.16.11-1.~),
Description: fantasy turn-based strategy game (branch 1.18)
 This package contains the main program for Wesnoth.  If you only want to
 play a few official campaigns, multiplayer games over the network with other
 players, user-made add-ons, and/or without music, install this package without
 recommended packages.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth
Architecture: all
Depends:
 wesnoth-1.18 (>= ${binary:Version}),
 wesnoth-1.18-data (= ${source:Version}),
 ${misc:Depends},
Description: fantasy turn-based strategy game (metapackage)
 This metapackage pulls in the main Wesnoth package which allows you to play
 using the latest stable version.  If you only want to play a few official
 campaigns, multiplayer games over the network with other players, user-made
 add-ons, and/or without music, install this package without recommended
 packages.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-music
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: music files for Wesnoth (branch 1.18)
 This package contains the music files for Wesnoth. It is not required but
 gives nice background music and encouraged.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-music
Architecture: all
Multi-Arch: foreign
Depends:
 wesnoth-1.18-data (= ${source:Version}),
 wesnoth-1.18-music (= ${source:Version}),
 ${misc:Depends},
Description: music files for Wesnoth (metapackage)
 This metapackage pulls in the music package for use with the latest stable
 version of wesnoth.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-server
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Description: multiplayer network server for Wesnoth (branch 1.18)
 This package contains the multiplayer network server for Wesnoth.  You need it
 if you want to host multiplayer games on your computer and don't want to use
 the official servers.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-tools
Architecture: all
Multi-Arch: foreign
Depends:
 python3:any,
 wesnoth-1.18-data (= ${source:Version}),
 ${misc:Depends},
 ${perl:Depends},
Recommends:
 imagemagick | graphicsmagick-imagemagick-compat,
Enhances:
 wesnoth-1.18 (>> 1:1.16.11-1.~),
 wesnoth-1.18-core (<< 1:1.16.11-1.~),
Description: tools for campaign developers for Wesnoth (branch 1.18)
 This package contains various tools for Wesnoth that are especially useful for
 campaign developers, including but not limited to scripts supporting the
 generation and checking of WML (Wesnoth Markup Language).  You can find them
 in the directory /usr/share/games/wesnoth/1.18/data/tools
 after installation of the package.
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-httt
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "Heir to the Throne" official campaign for Wesnoth (branch 1.18)
 This package contains the "Heir to the Throne" campaign for Wesnoth:
 "Fight to regain the throne of Wesnoth, of which you are the legitimate
 heir."
 (Novice level, 23 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-tsg
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "The South Guard" official campaign for Wesnoth (branch 1.18)
 This package contains the "The South Guard" campaign for Wesnoth:
 "A young Knight, Deoran, is dispatched to take command of the South Guard...
 Note: This campaign is designed as an introduction to Wesnoth. The 'Civilian'
 difficulty level is aimed at first-time players."
 (Novice level, 9 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-trow
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "The Rise of Wesnoth" official campaign for Wesnoth (branch 1.18)
 This package contains the "The Rise of Wesnoth" campaign for Wesnoth:
 "Lead Prince Haldric through the destruction of the Green Isle and across the
 Ocean to establish the very kingdom of Wesnoth itself. The confrontation with
 Lich-Lord Jevyan awaits..."
 (Intermediate level, 24 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-ttb
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "A Tale of Two Brothers" official campaign for Wesnoth (branch 1.18)
 This package contains the "A Tale of Two Brothers" campaign for Wesnoth:
 "An evil mage is threatening the small village of Maghre and its inhabitants.
 The village’s mage sends to his warrior brother for help, but not all goes as
 planned. Can you help?"
 (Novice level, 4 scenarios.)
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
 from one scenario to the next in a campaign.

Package: wesnoth-1.18-ei
Depends:
 wesnoth-1.18 (<< ${wesnoth:Max-Version}),
 wesnoth-1.18 (>= ${wesnoth:Min-Version}),
 ${misc:Depends},
Architecture: all
Description: "The Eastern Invasion" official campaign for Wesnoth (branch 1.18)
 This package contains the "The Eastern Invasion" campaign for Wesnoth:
 "There are rumors of undead attacks on the eastern border of Wesnoth. You, an
 officer in the Royal Army, have been sent to the eastern front to protect the
 villagers and find out what is happening."
 (Intermediate level, 16 scenarios.)"
 .
 Battle for control of villages, using variety of units which have advantages
 and disadvantages in different types of terrains and against different types
 of attacks.  Units gain experience and advance levels, and are carried over
